cd command behaves differently on same context in Red - rebol

See latest lines: from same context %/C/ directory, doing "cd rebol" works in one case and doesn't work in another case:
>> what-dir
== %/C/rebol/
>> cd ..
== %/C/
>> what-dir
== %/C/
>> cd rebol
== %/C/rebol/
>> what-dir
== %/C/rebol/
>> cd /
*** Script Error: / operator is missing an argument
*** Where: catch
*** Stack:
>> what-dir
== %/C/rebol/
>> cd ..
== %/C/
>> cd rebol
== %/C/rebol/
>> cd %/
== %/
>> what-dir
== %/C/
>> cd rebol
*** Access Error: cannot open: %/rebol/
*** Where: do
*** Stack: cd change-dir cause-error
>>

I am not on Windows right now, so I can't test it, but I believe there is problem here:
>> cd %/
== %/
>> what-dir
== %/C/
>> cd rebol
(...)
cd %/ changes directory to the root directory and that is definitely %/C/ as reported by what-dir.
So I guess what-dir is reporting wrong directory. I will try to add info later, when I will check it on Windows, or maybe someone will be faster and confirms it :)
You can also try read %/ to see what's there (it should be block of Windows drives).

There seems to be a difference between what-dir and pwd
>> ls
C/ D/ E/ Z/
>> pwd
%/
>> what-dir
== %/C/
>>
pwd and cd (change-dir) use system/options/path leading to the issue, that should be reported.
/ is the infix operator for a division. It will lead always to this error message if not in the rigth context
>> /
*** Script Error: / operator is missing an argument
*** Where: catch
*** Stack:
>> 10 / 5
== 2
>>

Related

how can I add my path to ~/.zshenv in order to install expo?

I am installing Android studio and following this instruction. https://docs.expo.dev/workflow/android-studio-emulator/
I need to add
[ -d "$HOME/Library/Android/sdk" ] && ANDROID_SDK=$HOME/Library/Android/sdk || ANDROID_SDK=$HOME/Android/Sdk
echo "export ANDROID_SDK=$ANDROID_SDK" >> ~/`[[ $SHELL == *"zsh" ]] && echo '.zshenv' || echo '.bash_profile'
and
echo "export PATH=$HOME/Library/Android/sdk/platform-tools:\$PATH" >> ~/`[[ $SHELL == *"zsh" ]] && echo '.zshenv' || echo '.bash_profile'`
to ~/.zshrc
what I did is,
from the android studio, I see my path is Users/myname/Library/Android/sdk therefore,
nano ~/.zshrc
open ~/.zshrc window.
and added this two line like this...
[ -d "Users/<myname>/Library/Android/sdk" ] && ANDROID_SDK=Users/<myname>/Library/Android/sdk || ANDROID_SDK=Users/<myname>/Android/Sdk
echo "export ANDROID_SDK=$ANDROID_SDK" >> ~/`[[ $SHELL == *"zsh" ]] && echo '.zshenv' || echo '.bash_profile'
and next line, I added..
echo "export PATH=Users/<myname>/Library/Android/sdk/platform-tools:\$PATH" >> ~/`[[ $SHELL == *"zsh" ]] && echo '.zshenv' || echo '.bash_profile'`
and it said, I need to make sure adb is working in terminal. So I typed adb in terminal, and it returns this err msg
zsh: command not found: adb
I am very new to shell things.. please help me!
You don't need to open the file with an editor: just run the two shell lines themselves in your terminal and they will append the EXPORT command to .zshenv with the proper ANDROID_SDK to be sourced next time you open the terminal and at the same time you'll the have ANDROID_SDK populated for your current session to keep on going with the setup.
The lines are doing the two following things:
Checking if $HOME/Library/Android/sdk exists: if so assign $HOME/Library/Android/sdk to ANDROID_SDK, else assign it $HOME/Android/Sdk
Checking if you're using zsh by running $SHELL == *"zsh": if so, append export ANDROID_SDK=$ANDROID_SDK to .zshenv, if not, append it to .bash_profile
If you wanted to do that manually, open .zshenv and append to it export ANDROID_SDK=$ANDROID_SDK (without the echo part) where $ANDROID_SDK is the directory above mentioned ( $HOME/Library/Android/sdk or $HOME/Android/Sdk depending on you having the $HOME/Library/Android/sdk directory or not )

MSYS2 path to Windows clipboard

Is there a way to copy a Unix path from the MSYS2 bash shell to the Windows clipboard?
A work-around is to start a Windows explorer with the current directory: /c/windows/explorer .
The MSYS2 pwd command has a -W switch to output the current path as Windows path (with forward slashes).
The Windows clipboard can be accessed as a Unix device: /dev/clipboard
So this makes a shell function like this:
# pathw [-c] [dir]
pathw () {
local p=''
local clip=false
if [ "$1x" = "-cx" ]; then
clip=true
shift
fi
if [ "$1x" = "x" ]; then
p=$(pwd -W)
else
p=$(cd $1 && pwd -W)
fi
p=$(echo $p | sed 's|/|\\|g')
echo $p
if [ "$clip" = true ]; then
echo $p > /dev/clipboard
fi
}
pathw ~
C:\msys64\home\weberjn

Running Celery as daemon won't use redis broker

I have
celery==3.1.23
Django==1.9.1
redis==2.10.5
ii redis-server 2:2.8.19-3 amd64 Persistent key-value database with networ
ii redis-tools 2:2.8.19-3 amd64 Persistent key-value database with networ
My configuration settings have the lines
# Celery
BROKER_URL = 'redis://127.0.0.1:6379/0'
BROKER_TRANSPORT = 'redis'
# start worker with '$ celery -A intro worker -l debug'
and my configuration file celery.py (standard practice is to name it this way, but confusing in my opinion) is
from __future__ import absolute_import
import os
import django
from celery import Celery
from django.conf import settings
os.environ.setdefault('DJANGO_SETTINGS_MODULE', 'intro.settings')
django.setup()
app = Celery('intro')
app.config_from_object('django.conf:settings')
app.autodiscover_tasks(lambda: settings.INSTALLED_APPS)
The config /etc/default/celeryd (also confusing naming) is
# copy this file to /etc/default/celeryd
CELERYD_NODES="w1 w2 w3"
VIRTUAL_ENV_PATH="/srv/intro/bin"
# JRT
CELERY_BIN="${VIRTUAL_ENV_PATH}/celery"
# Where to chdir at start.
CELERYD_CHDIR="/srv/intro/intro"
# Python interpreter from environment.
ENV_PYTHON="$VIRTUAL_ENV_PATH/python"
# How to call "manage.py celeryd_multi"
CELERYD_MULTI="$ENV_PYTHON $CELERYD_CHDIR/manage.py celeryd_multi"
# How to call "manage.py celeryctl"
CELERYCTL="$ENV_PYTHON $CELERYD_CHDIR/manage.py celeryctl"
# Extra arguments to celeryd NOTE --beat is vital, otherwise scheduler
# will not run
CELERYD_OPTS="--concurrency=1 --beat"
# %n will be replaced with the nodename.
CELERYD_LOG_FILE="/var/log/celery/%n.log"
CELERYD_PID_FILE="/var/run/celery/%n.pid"
# Workers should run as an unprivileged user.
CELERYD_USER="jimmy"
CELERYD_GROUP="jimmy"
# Name of the projects settings module.
export DJANGO_SETTINGS_MODULE="intro.settings"
#CELERY_BROKER_URL = 'redis://127.0.0.1:6379/0'
#export DJANGO_SETTINGS_MODULE="settings"
#CELERYD_MULTI="/home/webapps/.virtualenvs/crowdstaff/bin/django-admin.py celeryd_detach"
My /etc/init.d/celeryd file is
#!/bin/sh -e
VERSION=10.1
echo "celery init v${VERSION}."
if [ $(id -u) -ne 0 ]; then
echo "Error: This program can only be used by the root user."
echo " Unprivileged users must use the 'celery multi' utility, "
echo " or 'celery worker --detach'."
exit 1
fi
# Can be a runlevel symlink (e.g. S02celeryd)
if [ -L "$0" ]; then
SCRIPT_FILE=$(readlink "$0")
else
SCRIPT_FILE="$0"
fi
SCRIPT_NAME="$(basename "$SCRIPT_FILE")"
DEFAULT_USER="celery"
DEFAULT_PID_FILE="/var/run/celery/%n.pid"
DEFAULT_LOG_FILE="/var/log/celery/%n.log"
DEFAULT_LOG_LEVEL="INFO"
DEFAULT_NODES="celery"
DEFAULT_CELERYD="-m celery worker --detach"
CELERY_DEFAULTS=${CELERY_DEFAULTS:-"/etc/default/${SCRIPT_NAME}"}
# Make sure executable configuration script is owned by root
_config_sanity() {
local path="$1"
local owner=$(ls -ld "$path" | awk '{print $3}')
local iwgrp=$(ls -ld "$path" | cut -b 6)
local iwoth=$(ls -ld "$path" | cut -b 9)
if [ "$(id -u $owner)" != "0" ]; then
echo "Error: Config script '$path' must be owned by root!"
echo
echo "Resolution:"
echo "Review the file carefully and make sure it has not been "
echo "modified with mailicious intent. When sure the "
echo "script is safe to execute with superuser privileges "
echo "you can change ownership of the script:"
echo " $ sudo chown root '$path'"
exit 1
fi
if [ "$iwoth" != "-" ]; then # S_IWOTH
echo "Error: Config script '$path' cannot be writable by others!"
echo
echo "Resolution:"
echo "Review the file carefully and make sure it has not been "
echo "modified with malicious intent. When sure the "
echo "script is safe to execute with superuser privileges "
echo "you can change the scripts permissions:"
echo " $ sudo chmod 640 '$path'"
exit 1
fi
if [ "$iwgrp" != "-" ]; then # S_IWGRP
echo "Error: Config script '$path' cannot be writable by group!"
echo
echo "Resolution:"
echo "Review the file carefully and make sure it has not been "
echo "modified with malicious intent. When sure the "
echo "script is safe to execute with superuser privileges "
echo "you can change the scripts permissions:"
echo " $ sudo chmod 640 '$path'"
exit 1
fi
}
if [ -f "$CELERY_DEFAULTS" ]; then
_config_sanity "$CELERY_DEFAULTS"
echo "Using config script: $CELERY_DEFAULTS"
. "$CELERY_DEFAULTS"
fi
# Sets --app argument for CELERY_BIN
CELERY_APP_ARG=""
if [ ! -z "$CELERY_APP" ]; then
CELERY_APP_ARG="--app=$CELERY_APP"
fi
CELERYD_USER=${CELERYD_USER:-$DEFAULT_USER}
# Set CELERY_CREATE_DIRS to always create log/pid dirs.
CELERY_CREATE_DIRS=${CELERY_CREATE_DIRS:-0}
CELERY_CREATE_RUNDIR=$CELERY_CREATE_DIRS
CELERY_CREATE_LOGDIR=$CELERY_CREATE_DIRS
if [ -z "$CELERYD_PID_FILE" ]; then
CELERYD_PID_FILE="$DEFAULT_PID_FILE"
CELERY_CREATE_RUNDIR=1
fi
if [ -z "$CELERYD_LOG_FILE" ]; then
CELERYD_LOG_FILE="$DEFAULT_LOG_FILE"
CELERY_CREATE_LOGDIR=1
fi
CELERYD_LOG_LEVEL=${CELERYD_LOG_LEVEL:-${CELERYD_LOGLEVEL:-$DEFAULT_LOG_LEVEL}}
CELERY_BIN=${CELERY_BIN:-"celery"}
CELERYD_MULTI=${CELERYD_MULTI:-"$CELERY_BIN multi"}
CELERYD_NODES=${CELERYD_NODES:-$DEFAULT_NODES}
export CELERY_LOADER
if [ -n "$2" ]; then
CELERYD_OPTS="$CELERYD_OPTS $2"
fi
CELERYD_LOG_DIR=`dirname $CELERYD_LOG_FILE`
CELERYD_PID_DIR=`dirname $CELERYD_PID_FILE`
# Extra start-stop-daemon options, like user/group.
if [ -n "$CELERYD_CHDIR" ]; then
DAEMON_OPTS="$DAEMON_OPTS --workdir=$CELERYD_CHDIR"
fi
check_dev_null() {
if [ ! -c /dev/null ]; then
echo "/dev/null is not a character device!"
exit 75 # EX_TEMPFAIL
fi
}
maybe_die() {
if [ $? -ne 0 ]; then
echo "Exiting: $* (errno $?)"
exit 77 # EX_NOPERM
fi
}
create_default_dir() {
if [ ! -d "$1" ]; then
echo "- Creating default directory: '$1'"
mkdir -p "$1"
maybe_die "Couldn't create directory $1"
echo "- Changing permissions of '$1' to 02755"
chmod 02755 "$1"
maybe_die "Couldn't change permissions for $1"
if [ -n "$CELERYD_USER" ]; then
echo "- Changing owner of '$1' to '$CELERYD_USER'"
chown "$CELERYD_USER" "$1"
maybe_die "Couldn't change owner of $1"
fi
if [ -n "$CELERYD_GROUP" ]; then
echo "- Changing group of '$1' to '$CELERYD_GROUP'"
chgrp "$CELERYD_GROUP" "$1"
maybe_die "Couldn't change group of $1"
fi
fi
}
check_paths() {
if [ $CELERY_CREATE_LOGDIR -eq 1 ]; then
create_default_dir "$CELERYD_LOG_DIR"
fi
if [ $CELERY_CREATE_RUNDIR -eq 1 ]; then
create_default_dir "$CELERYD_PID_DIR"
fi
}
create_paths() {
create_default_dir "$CELERYD_LOG_DIR"
create_default_dir "$CELERYD_PID_DIR"
}
export PATH="${PATH:+$PATH:}/usr/sbin:/sbin"
_get_pidfiles () {
# note: multi < 3.1.14 output to stderr, not stdout, hence the redirect.
${CELERYD_MULTI} expand "${CELERYD_PID_FILE}" ${CELERYD_NODES} 2>&1
}
_get_pids() {
found_pids=0
my_exitcode=0
for pidfile in $(_get_pidfiles); do
local pid=`cat "$pidfile"`
local cleaned_pid=`echo "$pid" | sed -e 's/[^0-9]//g'`
if [ -z "$pid" ] || [ "$cleaned_pid" != "$pid" ]; then
echo "bad pid file ($pidfile)"
one_failed=true
my_exitcode=1
else
found_pids=1
echo "$pid"
fi
if [ $found_pids -eq 0 ]; then
echo "${SCRIPT_NAME}: All nodes down"
exit $my_exitcode
fi
done
}
_chuid () {
su "$CELERYD_USER" -c "$CELERYD_MULTI $*"
}
start_workers () {
if [ ! -z "$CELERYD_ULIMIT" ]; then
ulimit $CELERYD_ULIMIT
fi
_chuid $* start $CELERYD_NODES $DAEMON_OPTS \
--pidfile="$CELERYD_PID_FILE" \
--logfile="$CELERYD_LOG_FILE" \
--loglevel="$CELERYD_LOG_LEVEL" \
$CELERY_APP_ARG \
$CELERYD_OPTS
}
dryrun () {
(C_FAKEFORK=1 start_workers --verbose)
}
stop_workers () {
_chuid stopwait $CELERYD_NODES --pidfile="$CELERYD_PID_FILE"
}
restart_workers () {
_chuid restart $CELERYD_NODES $DAEMON_OPTS \
--pidfile="$CELERYD_PID_FILE" \
--logfile="$CELERYD_LOG_FILE" \
--loglevel="$CELERYD_LOG_LEVEL" \
$CELERY_APP_ARG \
$CELERYD_OPTS
}
kill_workers() {
_chuid kill $CELERYD_NODES --pidfile="$CELERYD_PID_FILE"
}
restart_workers_graceful () {
echo "WARNING: Use with caution in production"
echo "The workers will attempt to restart, but they may not be able to."
local worker_pids=
worker_pids=`_get_pids`
[ "$one_failed" ] && exit 1
for worker_pid in $worker_pids; do
local failed=
kill -HUP $worker_pid 2> /dev/null || failed=true
if [ "$failed" ]; then
echo "${SCRIPT_NAME} worker (pid $worker_pid) could not be restarted"
one_failed=true
else
echo "${SCRIPT_NAME} worker (pid $worker_pid) received SIGHUP"
fi
done
[ "$one_failed" ] && exit 1 || exit 0
}
check_status () {
my_exitcode=0
found_pids=0
local one_failed=
for pidfile in $(_get_pidfiles); do
if [ ! -r $pidfile ]; then
echo "${SCRIPT_NAME} down: no pidfiles found"
one_failed=true
break
fi
local node=`basename "$pidfile" .pid`
local pid=`cat "$pidfile"`
local cleaned_pid=`echo "$pid" | sed -e 's/[^0-9]//g'`
if [ -z "$pid" ] || [ "$cleaned_pid" != "$pid" ]; then
echo "bad pid file ($pidfile)"
one_failed=true
else
local failed=
kill -0 $pid 2> /dev/null || failed=true
if [ "$failed" ]; then
echo "${SCRIPT_NAME} (node $node) (pid $pid) is down, but pidfile exists!"
one_failed=true
else
echo "${SCRIPT_NAME} (node $node) (pid $pid) is up..."
fi
fi
done
[ "$one_failed" ] && exit 1 || exit 0
}
case "$1" in
start)
check_dev_null
check_paths
start_workers
;;
stop)
check_dev_null
check_paths
stop_workers
;;
reload|force-reload)
echo "Use restart"
;;
status)
check_status
;;
restart)
check_dev_null
check_paths
restart_workers
;;
graceful)
check_dev_null
restart_workers_graceful
;;
kill)
check_dev_null
kill_workers
;;
dryrun)
check_dev_null
dryrun
;;
try-restart)
check_dev_null
check_paths
restart_workers
;;
create-paths)
check_dev_null
create_paths
;;
check-paths)
check_dev_null
check_paths
;;
*)
echo "Usage: /etc/init.d/${SCRIPT_NAME} {start|stop|restart|graceful|kill|dryrun|create-paths}"
exit 64 # EX_USAGE
;;
esac
exit 0
Which is old, very long, and seems to contain nothing I can change to effect the broker used except the location of the default values script CELERY_DEFAULTS=/etc/default/celeryd (confusing name again). I admit I pretty well copied and pasted this script without a full understanding though I do know how init.d scripts work.
When I run /etc/init.d/celeryd start The workers start up, but ignore the BROKER django settings pointing to my redis server, and try to read RabbitMQ instead. The log file /var/log/celery/w1.log
[2016-11-30 23:44:51,873: ERROR/MainProcess] consumer: Cannot connect to amqp://guest:**#127.0.0.1:5672//: [Errno 111] Connection refused.
So celery is trying to use RabbitMQ, not Redis. There are other posts that complain of the same problem on Stack overflow, but none are resolved (as far as I can tell). I put djcelery in installed apps, as it seemed to make celeryd_multi management command available, but I don't want to use celery beat, and the documentation says this is no longer necessary. I have my own queue set up to run management commands, and I have had too many problems with setting up celerybeat in the past.
I have got the thing working by running sudo -u jimmy /srv/intro/bin/celery -A intro worker & and this works and uses the correct Redis queue (does anyone know why is it called a broker?), but wont restart on server power cycle, does not write to the log files, and I just don't feel this is a clean way to run celery workers.
I don't really want to use /etc/init.d scripts as this is the old way of doing things, and running as upstart has come and gone to replace this, and now systemd is the supported way of doing this (please correct me if I am wrong). There is no mention of these methods on the official documentation
http://docs.celeryproject.org/en/v4.0.0/userguide/daemonizing.html#init-script-celeryd
which makes me think that celery is no longer being supported, and perhaps there is a better maintained way of doing this. It is a wonder it has not been built into the core.
I did find this
https://github.com/celery/celery/blob/3.1/extra/supervisord/supervisord.conf
but there is no mention of broker in the config files, and I doubt that this will help me using Redis.
How do I get Celery running as a daemon to start automatically on reboot, and use Redis as a message queue, or is my only way of using Celery for asynchronous running of functions in Django to use the RabbitMQ message queue?
To ensure celery loads the correct broker, add broker parameter to Celery class.
app = Celery('intro', broker=settings.BROKER_URL)
Reference:
http://docs.celeryproject.org/en/latest/getting-started/first-steps-with-celery.html#application

Finding, from cocoa application, if a package installer (like DivXInstaller.pkg) is running

I do not know if this is possible, so I hope that the question does not appear stupid:
I can get in a cocoa application, or even using a bash script, the pid of a specific running Application. So I can take actions (such as alert and ask if you want to close it).
We can the same with a package (pkg), knowing its id (like "org.someIdentity.pkg") in some way?
EDIT
this is what i use in cocoa:
- (void)unWantedApp:(NSNotification *)notification {
NSDictionary *userInfo = [notification userInfo];
NSLog(#"userInfo == %#", userInfo);
if ([NSRunningApplication runningApplicationsWithBundleIdentifier:#"com.blabla"] || [NSRunningApplication runningApplicationsWithBundleIdentifier:#"com.blabla2"]) {
[[NSAlert alertWithMessageText:[NSString stringWithFormat:NSLocalizedString(#"blabla is running..", nil), [[NSBundle mainBundle] objectForInfoDictionaryKey:(NSString *)kCFBundleNameKey]]
defaultButton:nil alternateButton:nil otherButton:nil informativeTextWithFormat:NSLocalizedString(#"Well, I hope you are not joking with more then one Tool at same time...", nil)] runModal];
}
}
EDIT
what i used with bash:
isOpen=$(ps auxwww | grep '/Applications/blabla.app' | grep -v 'grep' | wc -l)
if [ -e '/Applications/blabla.app' ]; then
if [ $isOpen -ge 0 ]; then
# do what you are intresting for... But a packages is not in Application folder and is opened by Installer.app :-(
fi
fi
EDIT
also the bash script can be used in cocoa in this way:
#include <stdio.h>
#include <stdlib.h>
#define SCRIPT "\
#/bin/bash \n\
if [ -e '/Applications/blabla.app' ];then\n\
#variable and other statement here(escape all special caracter and manually add the new line ->> \n)\n\
else\n\
exit 0\n\
fi"
int main()
{
system(SCRIPT);
return 0;
}
Maybe this helps a bit:
app=${1:-VirtualBox} #tested on it
run_searched() {
echo "The installer installing $1 as: $2"
}
run_other() {
echo "The installer NOT installing $1. (but installing: $2)"
}
not_running() {
echo "The installer is not running"
}
isasdir="$HOME/Library/Saved Application State/com.apple.installer.savedState"
isasfile="$isasdir/windows.plist"
if [[ -d "$isasdir" && -f "$isasfile" ]]
then
win=$(plutil -p "$isasfile" | grep '"NSTitle"' | sed 's:.*"NSTitle".*=>.*"\([^"]*\)":\1:')
if [[ "$win" =~ $app ]]
then
run_searched "$app" "$win"
else
run_other "$app" "$win"
fi
else
not_running
fi
I added a comment with some questions, but I will provide some kind of answer too.
As mentioned in my comment: If the applications run with absolute path you can probably look for processes with org.someIdentity
If applications you want to 'monitor' are running from the same path(s), you could probably do something along these lines (bash):
apps="org.someIdentity org.someOtherIdentity"
for app in ${apps}; do
echo "Checking app ${app}..."
lsof /Applications/${app}
done
This is a crude example - you might have to expand on the paths a bit (I'm not on a Mac), but the idea is that the application/package names exist in the file structure (as directories). Running lsof on these directories will tell us which processes are using resources in that directory (i.e. opened files). Depending on your needs you can probably pass lsof some more parameters.
I'm not saying this is a very pretty approach, though ;)
If using OS X 10.8 or later, pgrep is the best tool to return a list of process IDs by application name.
$ pgrep firefox
905

How to make shell script loop not stop on error

I have a master shell script which called a child script for each iteration of a loop, like so:
#!/bin/bash
while read line
do
if [[ $line != "" ]]
then
./sslv2_check.sh $line
fi
done < https-servers
If any of those calls land in this case (see shell script below)
message="FAIL! $1 supports SSLv2 on port $port"
then the master script will stop and not call the next batch. How do I make it continue?
#!/bin/bash
# Required Argument $1 = hostname
# Optional Argument $1 = port number
if [[ $1 == "" ]]
then
echo Error: I expected a hostname to be passed as an argument but didn\'t find any
exit 1
fi
if [[ $2 == "" ]]
then
port=443
else
port=$2
fi
date=$(date +"%Y-%m-%d")
datetime=$(date +"%Y-%m-%d-%H-%M")
errorlogfile=logs/$date.error.log
logfile=logs/$date.log
# Testing for SSLv2
output=$(openssl s_client -connect $1:$port -ssl2 2>&1)
if [[ $output == *"handshake failure"* ]]
then
message="PASS! SSLv2 not supported by $1 on port $port"
elif [[ $output == *"104"* ]]
then
message="PASS! SSLv2 is not supported by $1 on port $port"
elif [[ $output == *"null ssl method passed"* ]]
then
message="ERROR! SSLv2 is not enabled on your local machine"
# Log error
echo "$datetime -- $message" >> $errorlogfile
echo $output >> $errorlogfile
elif [[ $output == *"110"* ]]
then
message="ERROR! Failed to connect to $1. Make sure you type in the hostname correctly etc."
# Log error
echo "$datetime -- $message" >> $errorlogfile
echo $output >> $errorlogfile
elif [[ $output == *"BEGIN CERTIFICATE"* ]]
then
message="FAIL! $1 supports SSLv2 on port $port"
# Log error
echo "$datetime -- $message" >> $errorlogfile
echo $output >> $errorlogfile
else
message="ERROR! An unknown error occurred. See $errorlogfile for details"
echo "$datetime -- $message" >> $errorlogfile
echo $output >> $errorlogfile
fi
#stdout the message
echo $message
#Log the message
echo "$datetime -- $message" >> $logfile
You can try this, the echo will always succeed if your other script fails.
if [[ $line != "" ]]
then
./sslv2_check.sh $line || echo "failed"
fi
Once openssl connects, it waits for input before closing. I don't know why but this is causing the master batch script to abort. The solution is as follows:
replace
output=$(openssl s_client -connect $1:$port -ssl2 2>&1)
with
output=$(echo 'GET HTTP/1.0' | openssl s_client -connect $1:$port -ssl2 2>&1)